using System;
using System.Collections.Generic;
using System.Text;

namespace CustomAttributeDemo
{
    /// <summary>
    /// Classe dfinissant l'attribut personnalis
    /// </summary>
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Field, Inherited=false, AllowMultiple=false)]
    public class DisplayAttribute : Attribute
    {
        private bool display = false;

        /// <summary>
        /// Constructeur par dfaut
        /// </summary>
        public DisplayAttribute(bool display)
        {
            this.display = display;
        }

        /// <summary>
        /// Obtient ou dfini une valeur indiquant si la proprit suivi a t modifi
        /// </summary>
        public bool Display
        {
            get
            {
                return this.display;
            }
        }
    }
}
