using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace CustomAttributeDemo
{
    public partial class InformationsDisplayer : UserControl
    {

        private Informations informations;

        public InformationsDisplayer()
        {
            InitializeComponent();
        }

        public Informations Informations
        {
            get
            {
                return this.informations;
            }

            set
            {
                this.informations = value;
                this.UpdateInformations();
            }

        }

        private void UpdateInformations()
        {
            this.listViewInformations.Clear();
            this.listViewInformations.Columns.Clear();
            
            if( this.informations != null )
            {
                PropertyInfo[] pis = this.informations.GetType().GetProperties();
                foreach (PropertyInfo pi in pis)
                {
                    foreach (object o in pi.GetCustomAttributes(typeof(DisplayAttribute), false))
                    {
                        if (((DisplayAttribute)o).Display)
                        {
                            this.listViewInformations.Columns.Add(pi.Name);
                        }
                    }
                }

                List<string> val = new List<string>();
                for (int i = 0; i < this.listViewInformations.Columns.Count; i++)
                {
                    val.Add(this.informations.GetType().GetProperty(this.listViewInformations.Columns[i].Text).GetGetMethod().Invoke(this.informations, null).ToString());   
                }
                this.listViewInformations.Items.Add(new ListViewItem(val.ToArray()));
            }
        }

    }
}
